
define("tracker_ref_yhd.global_spm",["tracker_ref_yhd.uid","util_yhd.url"],function(uidUtil,urlUtil){
	
	var exports={};
	var COM_SYMBOL = '.';
	var Conf = {
		TPA: "data-tpa",
		TPC: "data-tpc",
		TPI: "data-tpi",
		TCS: "data-tcs",
		TCD: "data-tcd",
		TCI: "data-tci",
		PC:  "data-pc",
		TP:  "data-tc",
		TC:  "data-tp",
		EXPR_TAG: "a,area,button",
		TPA_CHILD_SIZE:"data-tpaChildSize",
		TPC_CHILD_SIZE:"data-tpcChildSize",
		TC_CHILD_SIZE:"data-tcChildSize",
		RESULT:{
			RESULT:"result",
			TP:"tp",
			TC:"tc",
			UNIID:"uniId",
			PAGETYPE:"pageType",
			PAGEID:"pageId"
		}
	};
	var pageType=null,
		pageId=null,
		//pageFlag参数，标示pageType和PageId是否计算过，如果计算过，不再计算
		//0:未计算，-1:计算过，但是不符合条件，1：计算成功，2：计算过但页面不支持自动打点
		pageFlag = 0;

	var uniId = uidUtil.genUID();

		//从当前点击的对象中获取打点信息	
	exports.getData=function(dom,tag) {
			initPageType();
			if (pageFlag == -1 || pageFlag == 2) {
				return null;
			}
			var spmData = new SpmData(dom,tag);
			return spmData.getData();
	};
		//从url中获取打点信息
	exports.getNewPageData=function(){
			initPageType();
			//TODO:暂时屏蔽掉
			//if (pageFlag == -1) {
			//	return null;
			//}

			//从当前url中获取tc、tp属性值
			var urlParams=urlUtil.getParams(location.href) || {};
			var tp=urlParams["tp"];
			var tc=urlParams["tc"];
			return getResultData(tp,tc);
	};
	//通过点击链接来进行页面刷新，适用于通过“window.location.reload()”这种方式，会自动在url中加上tp和tc参数
	//dom可能是一个元素的id字符串(有#号或者没#号)，或者是一个dom对象
	exports.reloadPage=function(dom){
		exports.refreshPage(window.location.href, dom);
	};
	//通过点击链接来进行页面刷新，适用于通过“window.location.href=”这种方式，会自动在url中加上tp和tc参数
	//dom可能是一个元素的id字符串(有#号或者没#号)，或者是一个dom对象
	exports.refreshPage=function(url, dom,tag) {
		var _url = appendTpTcToUrl(url, dom,tag);
		window.location.href = _url;
	};
	//通过点击链接来打开新页面，适用于通过“window.open()”这种方式，会自动在url中加上tp和tc参数
	//dom可能是一个元素的id字符串(有#号或者没#号)，或者是一个dom对象
	//name为打开的窗口名称，params为参数
	exports.openPage=function(dom, url, name, params) {
		var _url = appendTpTcToUrl(url, dom);
		var _name = '';
		if(typeof(name) != 'undefined' && name) {
			_name = name;
		}
		var _params = '';
		if(typeof(params) != 'undefined' && params) {
			_params = params;
		}
		window.open(_url, _name, _params);
	};
	
	//根据dom获取tp和tc并加到url中
	//dom可以是一个对象，或者是元素的id值
	function appendTpTcToUrl(url, dom,tag) {
		if( !url) {
			return '';
		}
		var paramType = typeof(dom);
		if(paramType == 'undefined' || !dom) {
			return url;
		}
		var domObj = null;
		if(paramType == 'string') {
			var objId = dom;
			var index = dom.indexOf("#");
			if(index === -1) {
				objId = "#" + objId;
			}
			domObj = $(objId);	
		}else if(paramType == 'object') {
			domObj = dom;
		}
		if(!domObj) {
			return url;
		}
		var spmData = exports.getData(domObj,tag);
		if(spmData) {
			var tp = spmData.tp;
			var tc = spmData.tc;
			var paramObj = {"tp":tp,"tc":tc};
			var _url = urlUtil.appendParams(url, paramObj);
			return _url;
		}else{
			return url;
		}
	}
	
	//code转为id 
	function glSpmcodeToId(mapType, code) {
		//_globalSpmDataModelJson在page_macro.ftl中定义
		if(typeof(_globalSpmDataModelJson) != 'undefined' && _globalSpmDataModelJson) {
			var id = 0;
			if(mapType) {
				id = _globalSpmDataModelJson[mapType][code];
			}else{
				id = _globalSpmDataModelJson[code];
			}
			if(id) {
				return id;
			}
		}
		return code;
	}
	
	function initPageType(){
		//当pageFlag为0的时候才需要计算
		//if (!pageFlag) {
			//获取pageType和pageId
			var pageInfo = $("meta[name=tp_page]").attr("content");
			pageInfo = checkTpPage(pageInfo);
			if (!pageInfo) {
				pageFlag = -1;
				return;
			}
			pageType = glSpmcodeToId(null, pageInfo[0]);
			pageId = pageInfo[1];
			//pageType=0表示该页面还没接入自动打点
			if(pageType && pageType == '0') {
				pageFlag = 2;
			}
		//}
	}

	//定义一个spm对象，里面存储spm相关数据
	function SpmData(dom,tag) {
		var me = this;
		me._dom = dom;
		me._opt = {};
		me.TAG=tag || Conf.EXPR_TAG;
		me.init();
	}

	SpmData.prototype = {
		init: function() {
			var me = this,
				_dom = me._dom;
			//dom的非空判断
			if (!_dom) {
				me.set(Conf.RESULT.RESULT, 0);
				return;
			}
			//如果不是jq对象，转换为jq对象.
			//console.log(_dom instanceof $);
			if (!(_dom instanceof $)) {
				_dom = $(_dom);
			}
			//标记判断是否已经计算过tc、tp值
			var pc = _dom.data(Conf.PC);
			if (pc == 1) {
				me.set(Conf.RESULT.RESULT, 1);
				return
			} else if (pc == -1) {
				me.set(Conf.RESULT.RESULT, 0);
				return
			}
			
			//获取area对象,如果不存在，return掉
			var tpa = getParent(_dom, Conf.TPA);
			if (tpa.length < 1) {
				me.set(Conf.RESULT.RESULT, 0);
				return;
			}
			//存储tpa值
			me.set(Conf.TPA, tpa.attr(Conf.TPA));

			//area对象获取到之后，给area下面的所有可点击元素添加index
			me.initTpaIndex(tpa);
			
			var selfTpi=_dom.data(Conf.TPI);
			//如果当前dom元素不存在tpi，被当成新插入的元素
			if(!selfTpi){
				me.initNewTpaIndex(_dom,tpa);
			}
			me.set(Conf.TPC, _dom.data(Conf.TPC));
			me.set(Conf.TPI, _dom.data(Conf.TPI));

			me.initTcdIndex(tpa);
			
			var tcs = getParent(_dom, Conf.TCS);
			var tcd = getParent(_dom, Conf.TCD);
			if (tcd.length > 0) {
				if(!tcs.attr(Conf.TCD)){
					me.initNewTcdIndex(tcd,tpa);
				}
				me.set(Conf.TCS, tcs.attr(Conf.TCS));
				me.set(Conf.TCD, tcd.attr(Conf.TCD));
				me.set(Conf.TCI, tcd.data(Conf.TCI)||1);
			}
			me.set(Conf.RESULT.RESULT, 1);
		},
		rebuildTP: function(oTP) {
			var ary = oTP.split(COM_SYMBOL);
			var tpa = glSpmcodeToId('SPM_AREA', ary[2]);
			var tpc = glSpmcodeToId('SPM_COM', ary[3]);
			return ary[0] + COM_SYMBOL + ary[1] + COM_SYMBOL + tpa + COM_SYMBOL + tpc + COM_SYMBOL + ary[4] + COM_SYMBOL + ary[5];
		},
		rebuildTC: function(oTC) {
			if(oTC.length == 0) {
				return oTC;
			}
			var ary = oTC.split(COM_SYMBOL);
			var tcs = glSpmcodeToId('SPM_SYSTEM_TYPE', ary[0]);
			var tcd = glSpmcodeToId('SPM_DATA_TYPE', ary[2]);
			return tcs + COM_SYMBOL + ary[1] + COM_SYMBOL + tcd + COM_SYMBOL + ary[3] + COM_SYMBOL + ary[4];
		},
		getData: function() {
			var me = this,
				_dom = $(me._dom);
			var result = me.get(Conf.RESULT.RESULT);
			if (!result) {
				_dom.data(Conf.PC, -1);
				return null;
			}
			var dataPc = _dom.data(Conf.PC);
			if (dataPc == 1) {
				var _tp = _dom.data(Conf.TP);
				var _tc = _dom.data(Conf.TC);
				var dataResult = getResultData(_tp,_tc)
				return dataResult;
			}
			
			var tpa = me.get(Conf.TPA);
			var tpc = me.get(Conf.TPC);
			var tpi = me.get(Conf.TPI);
			var tcs = me.get(Conf.TCS);
			var tcd = me.get(Conf.TCD);
			var tci = me.get(Conf.TCI);
			var tp = pageType + COM_SYMBOL + pageId + COM_SYMBOL + tpa + COM_SYMBOL + tpc + COM_SYMBOL + tpi + COM_SYMBOL + uniId;
			var tc='';
			if($.trim(tcs)!="" || $.trim(tcd)!=""){
				if($.trim(tcs)!="") {
					tc += tcs + COM_SYMBOL;
				}else{
					tc += '0.0' + COM_SYMBOL;
				}
				if($.trim(tcd)!="") {
					tc += tcd + COM_SYMBOL;
				}else{
					tc += '0.0' + COM_SYMBOL;
				}
				tc += tci;
			}
			
			tp = this.rebuildTP(tp);
			tc = this.rebuildTC(tc);
			
			_dom.data(Conf.TP, tp);
			_dom.data(Conf.TC, tc);
			_dom.data(Conf.PC, 1);

			var dataResult = getResultData(tp,tc);
			return dataResult;
		},
		//初始化tpa下面a链接的数据，初始化完毕后，打个标记data-tpaChildSize
		initTpaIndex:function(tpa){
			//先判断是否已经初始化过，如果初始化过，直接renturn
			var flag=tpa.data(Conf.TPA_CHILD_SIZE);
			var me=this;
			if(flag){
				return;
			}
			var children = tpa.find(me.TAG);
			flag=1;
			var com={};
			for (var i = 0, child; child = children[i]; i++) {
				//获取当前child的tpc属性
				child = $(child);
				var tpc = getParent(child, Conf.TPC);
				if (tpc.length < 1) {
					child.data(Conf.TPI, flag);
					child.data(Conf.TPC, 0);
					flag++;
				} else {
					//如果当前结点存在tpc属性，则在tpc属性里面查找
					var tpcChildren = tpc.find(me.TAG);
					if(tpcChildren.length==0){
						tpcChildren=tpc;
					}
					var tpcData = tpc.attr(Conf.TPC);
					var num=com[tpcData] || 1;
					for (var j = 0, tpcChild; tpcChild = tpcChildren[j]; j++) {
						if($(tpcChild).data(Conf.TPI)){
							continue;
						}
						$(tpcChild).data(Conf.TPC, tpcData);
						$(tpcChild).data(Conf.TPI, num);
						num++;
					}
					com[tpcData]=num+tpcChildren.length;
					//tpc的link数需要存储.
					tpc.data(Conf.TPC_CHILD_SIZE,com[tpcData]);
				}
			}
			//存储tpa的值
			tpa.data(Conf.TPA_CHILD_SIZE,flag);
		},
		//如果是新插入的dom元素，点击之后在原有基础上计算顺位
		initNewTpaIndex:function(child,tpa){
			
			var tpc = getParent(child, Conf.TPC);
			//默认读取tpa中数量
			if(tpc.length<1){
				var flag=tpa.data(Conf.TPA_CHILD_SIZE);
				flag++;
				child.data(Conf.TPC, 0);
				child.data(Conf.TPI, flag);
				tpa.data(Conf.TPA_CHILD_SIZE,flag);
			}else{
				var tpcIndex=tpc.data(Conf.TPC_CHILD_SIZE);
				tpcIndex++;
				child.data(Conf.TPC, tpc.attr(Conf.TPC));
				child.data(Conf.TPI, tpcIndex);
				tpc.data(Conf.TPC_CHILD_SIZE,tpcIndex);
			}
		},
		initTcdIndex:function(tpa){
			//获取tc data.
			//给area下面的tcd数据打上顺位
			var flag=tpa.data(Conf.TC_CHILD_SIZE);
			if(flag!=null){
				return;
			}
			var tcds = tpa.find("[data-tcd]");
			for (var i = 0, child; child = tcds[i]; i++) {
				child = $(child);
				child.data(Conf.TCI,i+1);
			}
			tpa.data(Conf.TC_CHILD_SIZE,tcds.length);
		},
		initNewTcdIndex:function(child,tpa){
			var flag=tpa.data(Conf.TC_CHILD_SIZE);
			flag++;
			tpa.data(Conf.TC_CHILD_SIZE,flag);
			child.data(Conf.TCI,flag);
		},

		get: function(k) {
			return this._opt[k];
		},
		set: function(k, v) {
			this._opt[k] = v;
		}
	};

	
function getResultData(tp,tc){
		
		var tp=tp ||"";
		var tc=tc || "";
		var tpa="";
		var tpc="";
		var tpi="";
		var tcs="";
		var tcsa="";
		var tcd="";
		var tcd="";
		var tcdt="";
		var tci="";
		var refPageTypeId="";
		var refUnid="";
		var refPageValue="";
		if(tp){
			var tpArr=tp.split(".");
			tpa=tpArr[2] || "";
			tpc=tpArr[3] || "";
			tpi = tpArr[4]||"";
			refPageTypeId=tpArr[0] || "";
			refUnid = tpArr[5] || "";
			refPageValue=tpArr[1] || "";
		}
		if(tc){
			var tcArr=tc.split(".");
			tcs=tcArr[0] || "";
			tcsa=tcArr[1] || "";
			tcd=tcArr[2] || "";
			tcdt=tcArr[3] || "";
			tci=tcArr[4] || "";
		}
		
		return {
			"tp": tp,
			"tc": tc,
			"tpa": tpa,
			"tpc": tpc,
			"tpi": tpi,
			"tcs": tcs,
			"tcsa": tcsa,
			"tcd": tcd,
			"tcdt": tcdt,
			"tci": tci,
			"pageTypeId": pageType,
			"pageValue": pageId,
			"unid": uniId,
			"refPageTypeId": refPageTypeId,
			"refUnid": refUnid,
			"refPageValue": refPageValue
		};
	}
	//检查页面是否具有pageType和pageId属性
	function checkTpPage(pageInfo) {
		if (!pageInfo) {
			return null;
		}
		var arr = pageInfo.split(COM_SYMBOL);
		return arr.length == 2 ? arr : null;
	}

	//获取父节点属性
	function getParent($dom, a) {
		return $dom.closest("[" + a + "]");
	}
	//loli.spm = me;
	return exports;

});