/******************************** 自定义Array方法 Start ***************************************/
Array.prototype.toTRACKERJSONString = function() {
	var jsonStr = "[";
	for ( var i = 0; i < this.length; i++) {
		if (this[i] instanceof Parameter) {
			if (this[i].value instanceof Array) {
				jsonStr += "{" + this[i].key + "=" + this[i].value.toTRACKERJSONString() + "}" + ",";
			} else {
				jsonStr += this[i].toJSONString() + ",";
			}
		}
	}
	if (jsonStr.indexOf(",") > 0){
		jsonStr = jsonStr.substring(0, jsonStr.length - 1);
	}
	return jsonStr + "]";

};
/******************************** 自定义Array方法 End *****************************************/


/******************************** 自定义Parameter封装对象 Start *******************************/
function Parameter(key, value) {
	this.key = key;
	//如果是搜索关键字，则值中可能有中文，需转码
	if (this.key == "internalKeyword") {
		this.value = encodeURIComponent(value);
	} else {
		this.value = value;
	}

	this.toJSONString = function() {
		return "{" + this.key + "=" + this.value + "}";
	};
}
/******************************** 自定义Parameter封装对象 End *********************************/


/******************************** 对发送数据Url增加公共字段 Start *****************************/
function addPublicParameter(url) {
	//当前页URL
	//url += "&w_url=" + encodeURIComponent(location.href);
	//浏览器版本
	url += "&s_iev=" + navigator.userAgent||'';
	//平台类型
	//url += "&s_plt=" + navigator.platform||'';
	//屏幕分辨率
	url += "&s_rst=" + window.screen.width + "*" + window.screen.height;
	//来源页地址
	//url += "&w_rfu=" + encodeURIComponent(document.referrer||'');
	
	return url;
}
/******************************** 对发送数据Url增加公共字段 Start *****************************/


/******************************** 定义可以发送的数据键值对 Start ******************************/
var trackerSupportKey = new Object();
trackerSupportKey['infoPageId'] = 'w_pif';
trackerSupportKey['tp'] = 'w_tp';
trackerSupportKey['tc'] = 'w_tc';
trackerSupportKey['attachedInfo'] = 'b_ai';
trackerSupportKey['tracker_u'] = 'b_tu';
trackerSupportKey['tracker_type'] = 'b_trt';
trackerSupportKey['ip'] = 'u_ip';
trackerSupportKey['infoTrackerSrc'] = 'w_ts';
trackerSupportKey['infoTrackerSrc'] = 'w_ts';
trackerSupportKey['cookie'] = 'w_ck';
trackerSupportKey['orderCode'] = 'b_oc';
trackerSupportKey['endUserId'] = 'u_uid';
trackerSupportKey['firstLink'] = 'w_flk';
trackerSupportKey['productId'] = 'b_pid';
trackerSupportKey['curMerchantId'] = 'u_cm';
trackerSupportKey['provinceId'] = 'u_pid';
trackerSupportKey['fee'] = 'b_fee';
trackerSupportKey['edmActivity'] = 'b_ea';
trackerSupportKey['edmEmail'] = 'b_ee';
trackerSupportKey['edmJobId'] = 'b_ejb';
trackerSupportKey['internalKeyword'] = 'b_ik';
trackerSupportKey['resultSum'] = 'b_rs';
trackerSupportKey['currentPage'] = 'b_scp';
trackerSupportKey['linkPosition'] = 'b_lp';
trackerSupportKey['buttonPosition'] = 'b_bp';
trackerSupportKey['adgroupKeywordID'] = 'b_ak';
trackerSupportKey['extField3'] = 'b_set';
trackerSupportKey['extField6'] = 'b_adt';
trackerSupportKey['extField7'] = 'b_pmi';
trackerSupportKey['extField8'] = 'b_tid';
trackerSupportKey['extField9'] = 'b_cid';
trackerSupportKey['extField10'] = 's_and';
trackerSupportKey['pageTypeId'] = 'w_pt';
trackerSupportKey['unid'] = 'w_un';
trackerSupportKey['pageValue'] = 'w_pv';
trackerSupportKey['refPageTypeId'] = 'w_rpt';
trackerSupportKey['refUnid'] = 'w_run';
trackerSupportKey['refPageValue'] = 'w_rpv';
trackerSupportKey['eventId'] = 'b_ei';
trackerSupportKey['labelId'] = 'b_li';
trackerSupportKey['filterInfo'] = 'b_fi';
trackerSupportKey['activityId'] = 'b_aci';
trackerSupportKey['listCategoryId'] = 'b_lci';
trackerSupportKey['pmStatusTypeId'] = 'b_pms';
trackerSupportKey['container'] = 's_ct';
trackerSupportKey['containerVersion'] = 's_ctv';
trackerSupportKey['platVersion'] = 's_pv';
trackerSupportKey['platform'] = 's_plt';
trackerSupportKey['phoneType'] = 's_pt';
trackerSupportKey['provider'] = 's_pro';
trackerSupportKey['netType'] = 's_nt';
trackerSupportKey['tpa'] = 'w_tpa';
trackerSupportKey['tpc'] = 'w_tpc';
trackerSupportKey['tpi'] = 'w_tpi';
trackerSupportKey['tcs'] = 'w_tcs';
trackerSupportKey['tcsa'] = 'w_tca';
trackerSupportKey['tcdt'] = 'w_tct';
trackerSupportKey['tcd'] = 'w_tcd';
trackerSupportKey['tci'] = 'w_tci';
trackerSupportKey['tce'] = 'w_tce';
trackerSupportKey['positionTypeId'] = 'b_pyi';
trackerSupportKey['siteType'] = 'b_st';
trackerSupportKey['latitude'] = 'u_lon';
trackerSupportKey['longitude'] = 'u_lat';
/******************************** 定义可以发送的数据键值对 End ********************************/


/******************************** 自定义封装需跟踪库存对象 Start ******************************/
function TrackerContainer() {
	//初始URL
	this.url = ('https:'== document.location.protocol ? 'https://' : 'http://') + 'tracker.yhd.com/tracker/newInfo.do?1=1';
	//添加公共参数
	this.url = addPublicParameter(this.url);
	
	this.parameterArray =[];
	this.stockArray = [];
	this.commonAttached = [];// 普通的附加对象（key->value）

	this.addParameter = function(parameter) {
		//后面的新加入的参数覆盖前面的参数
		for(var i=0,len=this.parameterArray.length;i<len;i++){
			if(this.parameterArray[i] && parameter && this.parameterArray[i].key == parameter.key){
				this.parameterArray[i].value=parameter.value;
				return;
			}
		}
		this.parameterArray.push(parameter);
	};
	
	// 增加库存
	this.addStock = function(productId, stockInfo){ 
		this.stockArray.push(new Parameter(productId, stockInfo));
	};
	
	// 增加普通的附加信息
	this.addCommonAttached = function(key, value) {
		this.commonAttached.push(new Parameter(key, value));
	};

	// 构建附加信息
	this.buildAttached = function() {
		if (this.stockArray.length > 0){
			this.commonAttached.push(new Parameter("1", this.stockArray));
		}
		if (this.commonAttached.length > 0){
			this.addParameter(new Parameter("attachedInfo", this.commonAttached.toTRACKERJSONString("attachedInfo")));// 增加库存信息
		}
	};

	//添加guid信息
	this.addParameter(new Parameter("guid", pub_attrs["guid"]));// guid
	this.addParameter(new Parameter("sessionId", pub_attrs["sessionId"]));// sessionId

	this.toUrl = function() {
		this.buildAttached();
		var bd = "&bd={";
		for ( var i = 0; i < this.parameterArray.length; i++) {
			var key = trackerSupportKey[this.parameterArray[i].key];
			var value = this.parameterArray[i].value;
			if(key){
				bd += key + "=" + value;
				if(i < this.parameterArray.length - 1){
					bd += "|";
				}
			}
		}
		bd += "}";
		
		return this.url + bd;
	};
}
/******************************** 自定义封装需跟踪库存对象 End ********************************/






/******************************** goTracker主方法 Start ***************************************/
function gotracker(type, buttonPosition, productId, jsonObject) {
	var goTrackerContainer=new  TrackerContainer();
	if(typeof setTrackerPublicParams!="undefined"){
		setTrackerPublicParams(goTrackerContainer);
	}
	if (buttonPosition) {
		goTrackerContainer.addParameter(new Parameter("buttonPosition",buttonPosition));
	}
	if (productId) {
		goTrackerContainer.addParameter(new Parameter("productId",productId));
	}
	if (typeof(type) == "number" && (type > 2 || type < 0)) {
		goTrackerContainer.addParameter(new Parameter("extField7",type));
	} else if(typeof(type) == "string") {
		var pmInfoId = Number(type);
		if(pmInfoId > 2 || pmInfoId < 0){
			goTrackerContainer.addParameter(new Parameter("extField7",pmInfoId));
		}
	}
	if(typeof(jsonObject) == "object" && jsonObject){
		for(var x in jsonObject){
			goTrackerContainer.addParameter(new Parameter(x,jsonObject[x]));
		}
	}
	var edmEmail = trackerGetCookie("edmEmail");
	if(edmEmail){
		goTrackerContainer.addParameter(new Parameter("edmEmail",edmEmail));
	}
	
	sendImgUrl(goTrackerContainer.toUrl());
}
/******************************** goTracker主方法 End *****************************************/


/******************************** Importent ***************************************************/
//新建trackerContainer对象，在调用方和tracker_hijack中会有调用
var trackerContainer=new  TrackerContainer();
/******************************** Importent ***************************************************/

function sendImgUrl(url){
	var id = "timg"+new Date().getTime();
	window[id]=new Image(1, 1);
	window[id].src=url;
}