/**
 * 
 * url解析相关方法
 * 
 * 
 */
define("util_yhd.url",function(require, exports, module){

	function isEmptyObject(obj){
		 if(!obj){
			 return true;
		 }
		for(var key in obj){
			return false;
		}
		return true;
	}
	
	//获取url中参数，返回object对象
	exports.getParams=function(u){
			u=$.trim(u);
			var parsedObj=exports.parseUrl(u);
			return parsedObj ? parsedObj.params:null;
	};
		//给url追加参数
	exports.appendParams=function(u,obj){
		var me=exports;
		if(isEmptyObject(obj)){
			return u;
		}
		var parsedObj=me.parseUrl(u);
		if(!parsedObj){
			return u;
		}
		var params=parsedObj.params;
		//参数合并
		for(var key in obj){
			if(obj.hasOwnProperty(key) && obj[key]){
					params[key]=obj[key];
			}
		}
		parsedObj.params=params;
		return me.toCusString(parsedObj);
	};
		//解析url，返回object{loc:http://www.yhd.com,params:{a:1,b:2},append:#aaaa}
	exports.parseUrl=function(u){
		var append="";
		var loc="";
		var _paramsUrl="";
		var params={};
		u=$.trim(u);
		if(u==""){
			return null;
		}
		//先分隔
		var arr=u.split("#");
		var locationWithParams=arr[0];
		
		//如果存在#，把#后面的数据存在append里面
		if(arr.length>=2){
			for(var i=1,len=arr.length;i<len;i++){
				append+="#"+arr[i];
			}
		}
		
		var sublength=locationWithParams.indexOf("?");
		var length=locationWithParams.length;
		
		if(sublength>0){
			loc=locationWithParams.substring(0,sublength);
			_paramsUrl=locationWithParams.substring(sublength+1,length);
		}else{
			loc=locationWithParams;
		}
		//var locWithParasArr=locationWithParams.split("?");
		//loc=locWithParasArr[0];
		//var _paramsUrl=locWithParasArr[1];
		if(_paramsUrl){
			// 这里的pairs是一个字符串数组
			var pairs = _paramsUrl.split("&");
			for ( var i = 0, len = pairs.length; i < len; i++) {
				var sign = pairs[i].indexOf("=");
				// 如果没有找到=号，那么就跳过，跳到下一个字符串（下一个循环）。
				if (sign == -1) {
					continue;
				}
				var aKey = pairs[i].substring(0, sign);
				var aValue = pairs[i].substring(sign + 1);
				params[aKey] = aValue;
			}
		}
		var result={
				"loc":loc,
				"params":params,
				"append":append
		};
		return result;
	};
	exports.toCusString=function(obj){
		var result=[];
		result.push(obj.loc);
		var params=obj.params;
		if(!isEmptyObject(params)){
			result.push("?");
			
			var flag=0;
			for(var key in params){
				if(params.hasOwnProperty(key) && params[key]){
					if(flag){
						result.push("&");
					}
					result.push(key+"="+params[key]);
					flag++;
				}
			}
		}
		if(obj.append){
			result.push(obj.append);
		}
		return result.join("");
		//判断是否为空对象
		
	};
});