define(['zepto' ,'template','fastclick','h5tonative','math','tracker_ref_yhd.global_spm'], function($, template,fastclick,h5tonative,math,spm) {
    fastclick.attach(document.body);
    var exports = {};

    // callid 说明  
    // 进入首页 1
    // 距离是否超过500m 2
    // 进入详情页 传入3
    // 进入结算页 传入4
    // 获取导航回调 5
    // 获取广告&公告回调 6
    // 获取详情页 7
    // 到货提醒 8
    // 修改地址 9
    // 登录之后 10
    // 存储list 11
    // 获取存储的list 12

    // 埋点初始化
    sendPvTracker();


    var provinceId,canBuyStatus;
    var categoryList;
    var loadedCategoryIndex=0;
    var selectProductList=[];
    var selectRayProduct = [];
    var isLogin = false;

    var ignoreScroll;
    var hasInit;

    var $modNav = $('.mod_nav'),
        $layoutProduct = $('.layout_product'),
        $productBtn = $('.product_box .num_box');

    $modNav.height($(window).height());
    $('.LG_right').height($(window).height());

    exports.init = function(res){
        if(hasInit){return;}
        res = JSON.parse(res);
        this.clientInfo = res.clientinfo;
        if(res.provinceId_s){
            var arr = res.provinceId_s.split('_');
            provinceId = arr[0];
            canBuyStatus = arr[1] == 1 ? true : false;
            if(!canBuyStatus){
                exports.showPrompt('该地址不支持雷购');
            }
            getThunderCategory(provinceId);
            isLogin = (res.isLogin == 1 ? true : false);
            hasInit = true;
            bindEvents();
        }else{
            exports.showError();
        }


    };

    function appendToSelectProductList(pmId,num,stockNum,price,rayBuyActiveId){
        var foundInList = false;
        for(var n=0;n<selectProductList.length;n++){
            var p = selectProductList[n];
            if(p.pmId === pmId){
                p.num = num;
                p.stockNum = stockNum;
                p.price = price;
                foundInList = true;
                break;
            }
        }

        if(!foundInList){
            selectProductList.push({
                pmId : pmId,
                num : num,
                stockNum : stockNum,
                price : price,
                rayBuyActiveId : rayBuyActiveId
            })
        }

        selectProductList = selectProductList.filter(function(el){
            return el.num>0;
        });

        if(selectProductList.length>0){
            var $modFixed = $('.mod_fixed');
            $modFixed.removeClass('hide');
            var priceAll=0,numAll=0;
            selectProductList.forEach(function(el,index){
                numAll = math.numAdd(numAll,el.num)
                priceAll = math.numAdd(math.numMulti(el.price,el.num),priceAll);
            });
            $modFixed.find('.num').html(numAll);
            $modFixed.find('.price').html(priceAll);
            $modNav.height($(window).height() - 56);
            $('.LG_right').height($(window).height()-56);
        }else{
            $('.mod_fixed').addClass('hide');
            $modNav.height($(window).height());
            $('.LG_right').height($(window).height());
        }
        saveListData();
    }

    function saveListData(){
        var dataObj = {
                "leigou" : {
                    "selectProductList" : selectProductList
                }
            };
        var data = JSON.stringify(dataObj);
        h5tonative.saveH5Data(data);
    }

    function getSaveListData(){
        h5tonative.getH5Data('{"id":"leigou","callid":"12"}');
    }

    exports.getSaveListDataCallback = function(res){
        var listObj;
        try{
            listObj = JSON.parse(res);
        }catch(e){
            listObj = null;
        }
        if(listObj){
            exports.backFromDetailorClearing(JSON.stringify(listObj.selectProductList));
        }
    };

    function setFirstEnterData(){
        var dataObj = {
            "leigouEnter" : {
                "isFirstEnter" : "true"
            }
        };
        var data = JSON.stringify(dataObj);
        h5tonative.saveH5Data(data);
    }

    function judgeIsFirstEnter(){
        h5tonative.getH5Data('{"id":"leigouEnter","callid":"13"}');
    }

    exports.judgeIsFirstEnterCallback = function(res){
        var enterObj;
        try{
            enterObj = JSON.parse(res);
        }catch(e){
            enterObj = null;
        }
        if(!enterObj || enterObj.isFirstEnter!=="true"){
            exports.showGuide();
            setFirstEnterData();
        }
    }

    function changeProductNum($product,dir,to,ishidePrompt){
        if(!$product || !$product.hasClass('product')){return;}
        var $products = $(".mod_product li.product[data-pmid='"+$product.attr("data-pmid")+"']");

        var pmId = $product.attr('data-pmId');
        var stockNum = $product.attr('data-stockNum');
        var price = $product.attr('data-price');
        var limitNumberPerUser = $product.attr('data-limitNumberPerUser');
        var shoppingCount = ~~$product.attr('data-shoppingCount') || 0;
        var rayBuyActiveId = ~~$product.attr('data-rayBuyActiveId') || 0;

        // var $num = $product.find('.num');
        var $num = $products.find('.num');
        var v = ~~$num.val();

        ishidePrompt = ishidePrompt || false;

        if(dir){
            v += dir;
            if(shoppingCount){
                if(dir>0 && v < shoppingCount){v = ~~shoppingCount;}
                else if(dir<0 && v < shoppingCount){v = 0;}
            }
        }else if(to != undefined){
            v = to;
        }

        if(v <= 0){
            v = 0;
            $products.find('.num_box').addClass('hide');
            $products.find('.buy_box').removeClass('hide');
            // $product.find('.num_box').addClass('hide');
            // $product.find('.buy_box').removeClass('hide');
        }else{
            $products.find('.num_box').removeClass('hide');
            $products.find('.buy_box').addClass('hide');
            // $product.find('.num_box').removeClass('hide');
            // $product.find('.buy_box').addClass('hide');                    
        }

        if(limitNumberPerUser && v > ~~limitNumberPerUser){
            if(!ishidePrompt){
                exports.showPrompt('该商品限购'+limitNumberPerUser+'件');
            }
            v =  ~~limitNumberPerUser;
        }

        if(v > ~~stockNum){
            if(!ishidePrompt){
                exports.showPrompt('已经把库存买空啦');
            }
            v = ~~stockNum;
        }

        $num.val(v);
        appendToSelectProductList(pmId,v,stockNum,price,rayBuyActiveId);
    }

    function bindEvents(){

        // TODO
        // 滚动
        var scrollTimer;
        $('.LG_right').on('scroll',function(){
            if(scrollTimer){
                clearTimeout(scrollTimer);
                scrollTimer = null;
            }
            scrollTimer = setTimeout(function(){
                checkScrollPosition(~~$('.LG_right').scrollTop());
                lazyLoadImage();
            },10);
        });

        /**
         * 分类导航
         */
        var navTimer;
        $modNav.on('click' , '#classification_con a' , function(){
            var categoryName = $(this).attr('data-name');
            var $self = $(this);
            //TODO  第一个特殊类目处理
            var index = $('#classification_con a').index($(this));

            try{
                // 分类打点
                var spmData=spm.getData(this);
                // console.log(spmData)
                gotracker("2","defaultButton",null,spmData);
            }catch(e){
                console.log(e)
            }

            if(categoryName){
                jumpToCategory(categoryName,index);
            }

            moveNavToCenter($self);

            if(!!navTimer){
                clearTimeout(navTimer);
                navTimer = null;
            }
            ignoreScroll = true;
            navTimer = setTimeout(function(){
                ignoreScroll = false;
            },200);
        });

        // 点击商品
        $layoutProduct.on('click',function(e){
            var $target = $(e.target);
            var $parent = $target.closest('li');

            if($parent.length===0){
                return;
            }

            var pmId = $parent.attr('data-pmId');
            var stockNum = $parent.attr('data-stockNum');
            var price = $parent.attr('data-price');
            var title = $parent.attr('data-title');

            if($target.hasClass('stopPropagation')){
                event.stopPropagation();

                if(!$parent.hasClass('disabled')){
                    if($target.hasClass('buy_box') || $target.hasClass('num_plus')){
                        if($parent.attr('data-rayBuyActiveId') && $parent.attr('data-rayBuyActiveId')>10000){
                            selectRayProduct = selectProductList.filter(function(el){
                                return el.rayBuyActiveId>10000;
                            });
                            if(selectRayProduct.length>=1){
                                exports.showPrompt('促销商品1天仅限购买1次哦~');
                                return;
                            }
                        }
                        changeProductNum($parent,1);

                        try{
                            var spmData=spm.getData($parent,'li');

                            spmData.tpa='999';
                            spmData.positionTypeId = '3';

                            gotracker(pmId,"add_cart",null,spmData);
                        }catch(e){
                            console.log(e);
                        }
                    }
                    if($target.hasClass('num_minus')){
                        changeProductNum($parent,-1);
                    }
                }
            }else{
                var $num = $parent.find('.num');
                var num =  ~~$num.val() || 0;

                var appUrl= "yhd://raybuydetail/";
                var params={
                        "form":"h5",
                        "callId":3,
                        "num":num,
                        "vProvinceId":provinceId,
                        "pmId":pmId,
                        "pmInfo":selectProductList,
                        "title":title
                    };
                try{
                    var spmData=spm.getData($parent,'li');
                    if(spmData){
                        params["tp"]=spmData.tp;
                        params["tc"]=spmData.tc;
                    }

                }catch(e){
                    console.log(e)
                }

                if(params && typeof params != "string"){
                    params = JSON.stringify(params);
                }

                h5tonative.goToNative(appUrl,params);
            }
        });

        $layoutProduct.on('click',function(e){
            var $target = $(e.target);
            if($target.hasClass('all')){
                $('.mod_product').addClass('open');
                var categoryName = $target.closest('.title_box').attr('id');
                jumpToCategory(categoryName);
                lazyLoadImage();
            }
        });


        /**
         * 查看全部公告
         */
        var $fixedBox = $('.fixed_box');

        $fixedBox.on('click' , function(e){
            var e = $(e.target),
                that = $(this);
            if(e.hasClass('fixed_bg') || e.hasClass('btn_close')){
                that.removeClass('show');
            }
        });

        if(!canBuyStatus){
            $('.mod_fixed').addClass('disabled');
        }

        $('.mod_fixed').on('click','.btn_buy,.buy_car',function(){
            if(!canBuyStatus){return;}
            selectRayProduct = selectProductList.filter(function(el){
                return el.rayBuyActiveId>10000;
            });
            if(selectRayProduct.length==1){
                if(selectProductList.length==1){
                    exports.showPrompt('买一件小雷普通商品才能换购哦~');
                    return;
                }
            }

            var appUrl= "yhd://raybuycheckorder/";
            var params={
                    "form":"h5",
                    "callId":4,
                    "vProvinceId":provinceId,
                    "pmInfo":selectProductList
                };
            try{
                // 去结算页打点
                var spmData=spm.getData($(this));
                if(spmData){
                    params["tp"]=spmData.tp;
                    params["tc"]=spmData.tc;
                }
            }catch(e){
                console.log(e)
            }

            if(params && typeof params != "string"){
                params = JSON.stringify(params);
            }

            h5tonative.goToNative(appUrl,params);
        });

        // 点击banner图
        $('.mod_banner').on('click','a',function(){
                         //埋点
            var spmData=spm.getData($(this),"a");
            console.log(spmData);
            gotracker("2","defaultButton",null,spmData);
            //banner 跳转

            var index = $(".mod_banner a").index($(this));
            var appVer = exports.clientInfo.clientAppVersion.split(".");

            if(appVer[0]>4){
                showBanner(index);
            } else if(appVer[0]==4){
                if(appVer[1]>0){
                    showBanner(index);
                } else if(appVer[1]==0){
                    if(appVer[2]>8){
                        showBanner(index);
                    }
                }
            }
        });
    }
    //banner跳转
    function showBanner(index){

        if(exports.banner[index].bigPic){
            var src = exports.banner[index].src;
            var newBanner = [];
            $.each(exports.banner,function(i,o){
                if(o.bigPic && o.bigPic !== ""){
                    newBanner.push(o);
                }
            });
            var param = {
                "selectPicSrc":src,
                "showShareIcon":true,
                "productImgs":newBanner,
                "isFromRaybuy":true
            };
            h5tonative.goToNative('yhd://bigimage/',JSON.stringify(param));
        } else if (exports.banner[index].detailLink) {
            var detailLink = exports.banner[index].detailLink;
            var pmId = parseInt(detailLink, 10);
            if (isNaN(pmId)) {
                h5tonative.goToNative("yhd://web/", '{"url":"' + detailLink + '"}');

            } else {
                var appUrl = "yhd://raybuydetail/";
                var num = 0;
                selectProductList.forEach(function (selectProduct) {
                    if (selectProduct.pmId == pmId) {
                        num = selectProduct.num;
                    }
                });
                var params = {
                    "form": "h5",
                    "callId": 3,
                    "num": num,
                    "vProvinceId": provinceId,
                    "pmId": pmId,
                    "pmInfo": selectProductList
                };

                h5tonative.goToNative(appUrl, JSON.stringify(params));
            }

        }


    }


    function moveNavToCenter($tag){
        var $slider = $tag.closest('.categoryListSlider');
        if($slider.length===0){return;}

        $slider.find('a.cur').removeClass('cur');
        $tag.addClass('cur');

        var $oneSlider = $slider.find('a');

        var allHeight = $oneSlider.length * $oneSlider.offset().height;
        var modNavHeight = $modNav.offset().height;

        if(modNavHeight>allHeight){
            return;
        }

        var tagTop = $tag.offset().top - $slider.offset().top;
        var tagHeight = $tag.offset().height;
        var modNavHeight = $modNav.offset().height;

        var middleOffset = modNavHeight/2 - tagHeight/2;
        var offset = ~~(middleOffset - tagTop);

        moveNav($slider,offset,true);
    }

    function moveNav($slider,offset,useAnimation){
        var $tag = $slider.find('a');

        var allHeight = $tag.length * $tag.offset().height;
        var modNavHeight = $modNav.offset().height;

        if(offset>=0){
            offset = 0;
        }else if(offset <= -allHeight + modNavHeight){
            offset = -allHeight + modNavHeight;
        }

        //if(useAnimation){
        //    $slider.addClass('useAnimation');
        //}else{
        //    $slider.removeClass('useAnimation');
        //}

        $modNav.scrollTop(-offset);
        //$slider.css({
        //    '-webkit-transform' : 'translateY('+offset+'px)',
        //    'transform' : 'translateY('+offset+'px)'
        //});
    }

    function jumpToCategory(name, index) {
        var $category = $('#' + name),
            thisDomTop = 0,
            offset = 0;

        if (index === 0) {
            $('.LG_right').scrollTop(0);
        } else {
            if ($category.length !== 0) {
                thisDomTop = $category.offset().top - offset + $('.LG_right').scrollTop();
                $('.LG_right').scrollTop(thisDomTop);
            }
        }
    }

    function getThunderCategory(provinceId){
        h5tonative.getRemoteData('{"urlpath":"/mobileservice/getThunderCategory","callid":5,"param":"provinceId='+provinceId+'"}');
    }

    function getThunderHomeBannerAndDes(provinceId){
        h5tonative.getRemoteData('{"urlpath":"/mobileservice/getThunderHomeBannerAndDes","callid":6,"param":"provinceId='+provinceId+'"}');
    }

    exports.getThunderCategoryCallback = function(res){
        res = JSON.parse(res);
        if(!res.rtn_code || res.rtn_code == 0){
            $modNav.addClass('show');
            res.data.unshift({
                "categoryId" : new Date().getTime(),
                "categoryName" : "活动推荐"
            });
            categoryList = res.data;
            var html = template('nav', res);
            $('#classification_con').empty().prepend(html);
            getThunderHomeBannerAndDes(provinceId);
        }else{
            exports.showError();
        }
    };



    exports.showConfirm = function(data){
        var html = template('confirm' , data);
        exports.removeConfirm();

        var $confirm = $(html);
        $('body').append($confirm);
        $confirm.addClass('show');
        $confirm.find('.btn_confirm').on('click',function(){
            data.confirm.fn && data.confirm.fn.apply();
        });
        $confirm.find('.btn_cancel').on('click',function(){
            data.cancel.fn && data.cancel.fn.apply();
        })
    };

    exports.removeConfirm = function(){
        if($('.fixed_confirm').length > 0){
            $('.fixed_confirm').remove();
        }
        if( $('.fixed_notice').length > 0){
            $('.fixed_notice').removeClass('show');
        }

    };

    exports.changeAddress = function(){
        h5tonative.goToNative('yhd://chooseaddress','{"form":"h5","callId":9,"fromTag":4}');
    };

    function initBanner(res){
        if(!res.data || !res.data.banner){return;}
        var $modBanner = $('.mod_banner');
        $modBanner.empty();
        if(res.data.banner && res.data.banner.length>0){
            $modBanner.addClass('show');
        }else{
            return;
        }

        var w = $modBanner.width();
        var h = $modBanner.height();

        if(w > 500){
            h = ~~h/w *500;
            w = 500;
        }

        res.data.banner = res.data.banner.map(function(el){
            return {src:fixSrcToSize(el.src,w*2,h*2)}
        });

        var html = template('bannerList',res.data);
        $modBanner.html(html);
    }

    exports.getThunderHomeBannerAndDesCallback = function(res){
        try{
            res = JSON.parse(res);
        }catch(e){
            res = res.replace(/\t/g,'');
            res = JSON.parse(res);
        }

        if(!res.rtn_code || res.rtn_code == 0){
            exports.banner = res.data.banner;
            initBanner(res);
        }
        loadProducts();
    };

    function loadProducts(){
        loadedCategoryIndex = loadedCategoryIndex || 0;
        //TODO  第一个特殊类目处理
        if(loadedCategoryIndex === 0){
            loadedCategoryIndex = loadedCategoryIndex+1;
        }

        if(!provinceId){return;}
        if(loadedCategoryIndex < categoryList.length){
            var categoryId = categoryList[loadedCategoryIndex].categoryId;
            if(loadedCategoryIndex === 1){
                h5tonative.getRemoteData('{"urlpath":"/mobileservice/getProductsByCategoryId","callid":7,"showloading":1,"param":"provinceId='+provinceId+'&categoryId='+categoryId+'"}');
            }else{
                h5tonative.getRemoteData('{"urlpath":"/mobileservice/getProductsByCategoryId","callid":7,"param":"provinceId='+provinceId+'&categoryId='+categoryId+'"}');
            }
        }else{
            lazyLoadImage();
            judgeIsFirstEnter();
            if(!h5tonative.yhdplatform.isios()){
                getSaveListData();
            }
        }
    }

    function getRandomColor(){
        var colors = ['#ff8a65','#4dd0e1','#91a7ff','#97d054','#ffc107','#f06292'];
        var randomIndex = Math.ceil(Math.random()*6);
        return colors[randomIndex];
    }

    exports.loadProductsCallBack = function(res){
        try{
            res = JSON.parse(res);
        }catch(e){
            var reg = /body={(\S*?)}/ig;
            res = res.replace(reg,function(i,n){return i.replace(/\"/ig,'\'')});
            res = JSON.parse(res);
        }

        if(!res.rtn_code || res.rtn_code == 0){
            if(canBuyStatus == 0){
                res.disabled = true;
            }
            res.dotColor = getRandomColor();
            res.index = loadedCategoryIndex;
            var html = template('mod_product', res);
            $('.layout_product').append(html);
            loadedCategoryIndex++;
            loadProducts();
        }else{
            exports.showError();
        }
    };

    exports.backFromDetailorClearing = function(res){
        clearList();
        res = JSON.parse(res);
        res.forEach(function(el,index){
            var $product = $('#product_' + el.pmId);
            if(!!$product){
                changeProductNum($product,0,el.num,true);
            }
        });
    }

    var promptTimer = null;
    exports.showPrompt = function(message){
        if($('.mod_prompt').length > 0){
            $('.mod_prompt').remove();
            clearTimeout(promptTimer);
            promptTimer = null;
        }
        var html = template('mod_prompt',{message:message});
        var $html = $(html);
        $('body').append($html);
        promptTimer = setTimeout(function(){
            $html.remove();
        },800)
    }

    function clearList(){
        var copyList = [];
        selectProductList.forEach(function(el,index){
            copyList.push(el.pmId);
        });
        copyList.forEach(function(el,index){
            changeProductNum( $('#product_' + el),0, 0);
        });
    }

    function checkScrollPosition(position){
        var modTopArray = [];
        var offset= 0;
        position-=offset;


        if($('.mod_banner').length > 0){
            modTopArray.push({
                pos:~~$('.mod_banner').offset().top + position,
                category:null
            });
        }

        $('.mod_product').each(function(){
            modTopArray.push({
                pos:~~$(this).offset().top + position,
                category:$(this)
            });
        });

        var range;
        var curCategory;
        for(var n=0,l=modTopArray.length;n<l;n++){
            if(modTopArray[n+1] && position >= modTopArray[n].pos && position < modTopArray[n+1].pos ) {
                range = n;
                curCategory=modTopArray[n].category;
                break;
            }else if(!modTopArray[n+1] && position >= modTopArray[n].pos){
                range = n;
                curCategory=modTopArray[n].category;
                break;
            }
        }

        var $fixed_productTitle = $('.fixed_productTitle');
        if (curCategory) {
           var $title_box = curCategory.find('.title_box');
            $fixed_productTitle.html($title_box[0].outerHTML);
            if(!$fixed_productTitle.hasClass('fixed_title')){
                $fixed_productTitle.addClass('fixed_title');
            }
        } else {
            $fixed_productTitle.removeClass('fixed_title');
            $fixed_productTitle.html('');
        }

        if(!ignoreScroll){
            if(range!==undefined ){
                moveNavToCenter($('#classification_con a').eq(range));
            }else{
                moveNavToCenter($('#classification_con a').eq(0));
            }
        }

    }

    function lazyLoadImage(){
        var top = ~~$(window).scrollTop();
        var height = $(window).height();

        $('.LG_oneBanner').each(function(index,el){
            var productTop = $(this).offset().top;
            if( productTop && productTop >= top && productTop < top + height){
                var $img = $(this).find('img');
                if($img.attr('data-src')){
                    var src = $img.attr('data-src');
                    src = fixSrcToSize(src,460,190);
                    $img.attr('src',src);
                    $img.removeAttr('data-src');
                }
            }
        });

        $('.product').each(function(index,el){
            var productTop = $(this).offset().top;
            if( productTop && productTop >= top && productTop < top + height){
                var $img = $(this).find('img');
                if($img.attr('data-src')){
                    var src = $img.attr('data-src');
                    src = fixSrcToSize(src,130,130);
                    $img.attr('src',src);
                    $img.removeAttr('data-src');
                }
            }
        });
    }

    function fixSrcToSize(src,x,y){
        var reg = /(_\d+x\d+)?\.(\w+)$/;
        var newSrc = src.replace(reg,function($1,$2,$3){
            return  '_' + x + 'x' + y + '.' + $3;
        });
        return newSrc;
    }

    exports.showError = function(){
        $('body').addClass('error');
        $('.LG_errorRefresh').off('click').on('click',function(){
            h5tonative.h5Refresh();
        });
    };

    exports.showGuide = function(){
        $('.LG_guide').addClass('show');
        setTimeout(function(){
            $('.LG_guide').removeClass('show');
        },5000);
        $('body').on('touchend',function(){
            $('.LG_guide').removeClass('show');
        });
    };


    return exports;
});
