define(['api', 'h5tonative', 'scrollLoad','tracker_ref_yhd.global_spm'],function(api, h5tonative, scrollLoad,spm){
var exports={};
exports.mount=function(){
	function stopScroll(e){
		e.preventDefault();
		e.stopPropagation();
	}

	/*
	以下为组件注册,声明在全局,页面载入时挂载.
	*/
	Vue.component('main-content',{
		//主要内容组件
		template:'#i-content',
		props:['content','index','typeid'],
		methods:{
			showDetail:function(event){
				event.preventDefault();
				var that=this,stopClick=this.$root.stopClick,
					$domSelect = $(that.$el),
					dataTpa = $domSelect.parents('.i-list-box').attr('data-tpa'),
					dataTpi = $domSelect.attr('data-tpi');

				if(stopClick==false){
					that.$root.stopClick=true;
					var req={
						top:$(event.target).parents('.i-module')[0].getBoundingClientRect().top,
						imgUrl:$(event.target).parents('.i-module').find('.i-module-pic').attr('src'),
						topicId:that.$data.content.id,
						date:that.content.date,
						typeId:that.$data.content.type
					}
					that.$dispatch('renderDetail',req);
					//hash change
				}

				$('meta[name=tp_page]').attr('content','80001.'+ that.$data.content.id);

				try{
					var spmData = spm.getData($domSelect);
					spmData.tpa = dataTpa;
					spmData.tpi = dataTpi;
					
					// console.log(spmData)
					gotracker("2","defaultButton",null,spmData);
		        }catch(e){
		            console.log(e);
		        }
			}
		}
	});
	//空态组件
	Vue.component('empty-state',{
	  template:'#emptyState',
	  props:['em', 'index'],
	  methods: {
	      reload: function() {
	      	window.location.reload();
	      }
	  }
	});
	Vue.component('detail-box',{
		//详情页组件
		template:'#detailBox',
		props:['detailData'],
		data:function(){
			return {
				goDetail:false,
				imgUrl:'',
				top:0,
				detailData:{},
				currentView:'imgText',
				id:'',
				date:{},
				typeId:0
			};
		},
		methods:{
			like:function(e){
				var that=this,$this= $(e);
				that.$dispatch('likeThis',{id:that.id});

				try{
		            var spmData=spm.getData($this);
		            spmData.tpa='4';
		            spmData.tpi='1';
		            gotracker("2","defaultButton",null,spmData);
		        }catch(e){
		            console.log(e);
		        }
			},
			goTop:function(){
				if(!$.isFunction($.fn.scrollTo)){
					$.fn.scrollTo = function(options){
						var defaults = {
							toT : 0,    //滚动目标位置
							durTime : 500,  //过渡动画时间
							delay : 30,     //定时器时间
							callback:null   //回调函数
						};
						var opts = $.extend(defaults,options),
							timer = null,
							_this = this,
							curTop = _this.scrollTop(),//滚动条当前的位置
							subTop = opts.toT - curTop,    //滚动条目标位置和当前位置的差值
							index = 0,
							dur = Math.round(opts.durTime / opts.delay),
							smoothScroll = function(t){
								index++;
								var per = Math.round(subTop/dur);
								if(index >= dur){
									_this.scrollTop(t);
									window.clearInterval(timer);
									if(opts.callback && typeof opts.callback == 'function'){
										opts.callback();
									}
									return;
								}else{
									_this.scrollTop(curTop + index*per);
								}
							};
						timer = window.setInterval(function(){
							smoothScroll(opts.toT);
						}, opts.delay);
						return _this;
					};
				}
				$('.i-detail').scrollTo();
			}
		},
		events:{
			//打开详情页,并执行动画
			openDetail:function(msg){
				var that=this;
				var $this=$(that.$el);
				console.log(msg.msg,11)
				//渲染数据
				this.imgUrl=msg.msg.imgUrl || msg.detailData.imgUrl;
				this.goDetail=true;
				this.top=msg.msg.top || 0;
				this.currentView=msg.currentView;
				this.detailData=msg.detailData;
				this.date=msg.msg.date || msg.detailData.date;
				this.id=msg.msg.topicId;
				this.typeId=msg.msg.typeId || msg.detailData.type;

				// alert(JSON.stringify(this.date))
				document.querySelector('.i-main-list').addEventListener('touchmove',stopScroll,false);
				//动画
				$('.i-detail').addClass('i-bottom').velocity({top:that.top},{duration:0})
				.velocity({
					top:0
				},
				{
					duration:200,
					complete:function(){
						$('.i-detail-btn').css('z-index', '333');
						$('.i-component-append,.i-detail-btn').velocity('fadeIn',{duration:150});
						//是否点过赞
						if(msg.detailData.isPraised){
							$('.detail_01-heart').addClass('i-like');
						}else{
							$('.detail_01-heart').removeClass('i-like');
						}
						//显示分享
						h5tonative.showShareButton('{"title":"'+ msg.detailData.title +'","content":"用品质点缀生活，用趣味装扮心情，更多精选新鲜好货尽在1号店1品堂频道","imageUrl":"'+msg.detailData.imgUrl+'","url":"http://mxc.yhd.com/yptShare-v3/detail.html?topicId='+msg.msg.topicId+'"}');

					}
				}).velocity("finish");
				$('.i-module').velocity({'opacity':0},{'visibility':'hidden'},{duration:200});
			},
			goBack:function(msg){
				var $this=$(this.$el),that=this;
				if(that.goDetail==false)return;
				$('.i-component-append,.i-detail-btn').velocity('fadeOut',{
					duration:0
				});
				$('.i-detail').removeClass('i-bottom').velocity({top:0},{duration:0}).velocity({top:that.top},{
					duration:200,
					complete:function(){
						$('.i-module').velocity('reverse',{duration:400,complete:function(){
							setTimeout(function(){
								that.goDetail=false;
								that.imgUrl='';
								that.$root.stopClick=false;
								document.querySelector('.i-main-list').removeEventListener('touchmove',stopScroll,false);
							},200);
							that.top=0;
							scrollLoad.resume();
						}});
						//隐藏分享
						if(h5tonative.yhdplatform.isios()){
							h5tonative.showShareButton();
						}
						if(h5tonative.yhdplatform.isandroid()){
							h5tonative.showShareButton('{}');
						}
					}
				}).velocity("finish");

			}
		}
	});
	Vue.component('detail-g-content',{
		//攻略图文
		template:'#g-text',
		props:['detaildata'],
		methods:{
			goodsDetail:function(e,index){
				var dom = $(e.target).closest('.list-li')[0];
				var spmData = spm.getData(dom,dom.tagName);
				var url=this.detaildata.products[index].productDetailUrl.replace(/\'/g,'\"');

				if(/^http/.test(url)){
		   			h5tonative.goToNative("yhd://web/", '{"url":"' + url + '"}');
		   		}else{
		   			var urlArr = url.split('?body=');
		   			var params = JSON.parse(urlArr[1]);

					if(spmData){
						params["tp"] = spmData.tp;
						params["tc"] = spmData.tc;
					}
					if (params && typeof params != "string") {
	                    params = JSON.stringify(params);
	                }
		   			h5tonative.goToNative(urlArr[0],params);
		   		}
			}
		}
	});
	Vue.component('detail-g-content2',{
		//攻略 mutiProductsContent
		template:'#g-text2',
		props:['detaildata'],
		methods:{
			goodsDetail:function(e, outerindex, index){
				var dom = $(e.target).closest('.list-li')[0];
				var spmData = spm.getData(dom,dom.tagName);
				var url=this.detaildata.mutiProductsContent[outerindex].subProducts[index].productDetailUrl.replace(/\'/g,'\"');
				
				if(/^http/.test(url)){
		   			h5tonative.goToNative("yhd://web/", '{"url":"' + url + '"}');
		   		}else{
		   			var urlArr = url.split('?body=');
		   			var params = JSON.parse(urlArr[1]);

					if(spmData){
						params["tp"] = spmData.tp;
						params["tc"] = spmData.tc;
					}
	                if (params && typeof params != "string") {
	                    params = JSON.stringify(params);
	                }

		   			h5tonative.goToNative(urlArr[0],params);
		   		}
			}
		}
	});

	Vue.component('content-img',{
		//图文组件
		template:'<div class="exploded-infor">'+
						'<div class="exploded-illustration">'+
							'<div class="exploded-content">{{{detaildata.content}}}</div>'+
						'</div>'+
					'</div>',
		props:['detaildata']
	});

	Vue.component('scene-page',{
		//场景购
		template:'#scene-buy',
		props:['mutiproductscontent'],
		methods: {
	      jumpTo: function(e, outerindex, index) {
	      		var dom = $(e.target).closest('.related-li')[0];
			    var spmData = spm.getData(dom,dom.tagName);
				var url = this.mutiproductscontent[outerindex].subProducts[index].productDetailUrl.replace(/\'/g,'\"');
				
	      	if(/^http/.test(url)){
		   			h5tonative.goToNative("yhd://web/", '{"url":"' + url + '"}');
		   		}else{
		   			var urlArr = url.split('?body=');
		   			var params = JSON.parse(urlArr[1]);
				    if(spmData){
					  params["tp"] = spmData.tp;
					  params["tc"] = spmData.tc;
				    }
	                if (params && typeof params != "string") {
	                    params = JSON.stringify(params);
	                }
		   			h5tonative.goToNative(urlArr[0],params);
		   		}
	      }
	  }
	});
	Vue.component('detail-content',{
		//详情页内容组件
		template:'#detail-main',
		props:['detaildata']
	});
	Vue.component('type-btn',{
		//类型选项组件
		template:'#type-list',
		props:['name','index','class','id'],
		methods:{
			choose:function(e){
				e.stopPropagation();
				this.$dispatch('change-class',{class:this.class,index:this.index,id:this.id});
			}
		}
	});

	Vue.component('keyword-list',{
		//关键字组件
	   template:'#i-keywords',
	   props:['keywords'],
	   methods:{
	   	openLink:function(e,index){
	   		var dom = $(e.target)[0];
			var spmData = spm.getData(dom,dom.tagName);
	   		var url=this.keywords[index].link.replace(/\'/g,'\"');

	   		if(/^http/.test(url)){
	   			h5tonative.goToNative("yhd://web/", '{"url":"' + url + '"}');
	   		}else{
	   			var urlArr = url.split('?body=');
		   		var params = JSON.parse(urlArr[1]);

				if(spmData){
					params["tp"] = spmData.tp;
					params["tc"] = spmData.tc;
				}

                if (params && typeof params != "string") {
                    params = JSON.stringify(params);
                }

	   			h5tonative.goToNative(urlArr[0],params);
	   		}

	   	}
	   }
	});

	Vue.component('sndb-lock',{
		//排行榜组件
	   template:'#i-sndblock',
	   props:['mutiproductscontent'],
	   methods: {
	   	jumpTo: function(e, outerindex, index) {
	   		var dom = $(e.target).closest('.recommend_item')[0];
			var spmData = spm.getData(dom,dom.tagName);
	   		var url = this.mutiproductscontent[outerindex].subProducts[index].productDetailUrl.replace(/\'/g,'\"');

	   		if(/^http/.test(url)){
	   			h5tonative.goToNative("yhd://web/", '{"url":"' + url + '"}');
	   		}else{
	   			var urlArr = url.split('?body=');
	   			var params = JSON.parse(urlArr[1]);

				if(spmData){
					params["tp"] = spmData.tp;
					params["tc"] = spmData.tc;
				}

                if (params && typeof params != "string") {
                    params = JSON.stringify(params);
                }

	   			h5tonative.goToNative(urlArr[0],params);
	   		}
	   	}
	   }
	});

	Vue.component('detail-title',{
		//详情页标题组件
		template:'<div class="exploded-about">'
					+'<div class="exploded-title"><p>{{title}}</p></div>'
					+'<div class="i-date i-date-detail">'
						+'<div class="i-date1">{{date.day}}</div>'
						+'<div class="i-date2">'
							+'<p class="i-date-cn">{{date.month}}月</p>'
							+'<p class="i-date-en">{{date.en}}</p>'
						+'</div>'
					+'</div>'
				+'</div>',
		props:['title','date']
	});


	Vue.component('recommended-list',{
		//场景购物商推荐组件
	  template:'#i-recommended',
	  props:['products'],
	  methods: {
	      jumpTo: function(e,index) {
	   		var dom = $(e.target).closest('.related-li')[0];
			var spmData = spm.getData(dom,dom.tagName);
	      	var url=this.products[index].productDetailUrl.replace(/\'/g,'\"');
	      
	      	if(/^http/.test(url)){
		   		h5tonative.goToNative("yhd://web/", '{"url":"' + url + '"}');
	   		}else{
	   			var urlArr = url.split('?body=');
	   			var params = JSON.parse(urlArr[1]);

				if(spmData){
					params["tp"] = spmData.tp;
					params["tc"] = spmData.tc;
				}

	                if (params && typeof params != "string") {
	                    params = JSON.stringify(params);
	                }
	   			h5tonative.goToNative(urlArr[0],params);
	   		}
	      }
	  }
	});
}
return exports;
});
